|
|
0a122b |
From 5f1f1921575005ea286f1eb408f62064728df972 Mon Sep 17 00:00:00 2001
|
|
|
0a122b |
From: Jeffrey Cody <jcody@redhat.com>
|
|
|
0a122b |
Date: Wed, 20 Nov 2013 19:44:08 +0100
|
|
|
0a122b |
Subject: [PATCH 25/25] block: vhdx qemu-iotest - log replay of data sector
|
|
|
0a122b |
|
|
|
0a122b |
RH-Author: Jeffrey Cody <jcody@redhat.com>
|
|
|
0a122b |
Message-id: <1a13302bddec68d7ee3e2f3be3a457c4bc61eea4.1384975172.git.jcody@redhat.com>
|
|
|
0a122b |
Patchwork-id: 55818
|
|
|
0a122b |
O-Subject: [RHEL7 qemu-kvm PATCH 25/26] block: vhdx qemu-iotest - log replay of data sector
|
|
|
0a122b |
Bugzilla: 879234
|
|
|
0a122b |
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
|
|
|
0a122b |
RH-Acked-by: Paolo Bonzini <pbonzini@redhat.com>
|
|
|
0a122b |
RH-Acked-by: Fam Zheng <famz@redhat.com>
|
|
|
0a122b |
|
|
|
0a122b |
This tests the replay of a data sector in a VHDX image file.
|
|
|
0a122b |
|
|
|
0a122b |
The image file is a 10G dynamic image, with 4MB block size. The
|
|
|
0a122b |
image was created with qemu-img, and the log left unplayed by
|
|
|
0a122b |
modification of the vhdx image format driver.
|
|
|
0a122b |
|
|
|
0a122b |
It was verified under both QEMU and Hyper-V that the image file,
|
|
|
0a122b |
post log replay, matched.
|
|
|
0a122b |
|
|
|
0a122b |
Signed-off-by: Jeff Cody <jcody@redhat.com>
|
|
|
0a122b |
Signed-off-by: Stefan Hajnoczi <stefanha@redhat.com>
|
|
|
0a122b |
(cherry picked from commit e78835b722eb26f5a56370166e99b69e9751ea2a)
|
|
|
0a122b |
|
|
|
0a122b |
Conflicts:
|
|
|
0a122b |
tests/qemu-iotests/group
|
|
|
0a122b |
|
|
|
0a122b |
RHEL7 Notes: Conflict due to test number leapfrogging tests that have
|
|
|
0a122b |
not yet been backported into RHEL7.
|
|
|
0a122b |
|
|
|
0a122b |
Signed-off-by: Jeff Cody <jcody@redhat.com>
|
|
|
0a122b |
---
|
|
|
0a122b |
tests/qemu-iotests/070 | 67 +++++++++++++++++++++
|
|
|
0a122b |
tests/qemu-iotests/070.out | 8 +++
|
|
|
0a122b |
tests/qemu-iotests/group | 1 +
|
|
|
0a122b |
4 files changed, 76 insertions(+)
|
|
|
0a122b |
create mode 100755 tests/qemu-iotests/070
|
|
|
0a122b |
create mode 100644 tests/qemu-iotests/070.out
|
|
|
0a122b |
|
|
|
0a122b |
Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
|
|
|
0a122b |
---
|
|
|
0a122b |
tests/qemu-iotests/070 | 67 ++++++++++++++++++++++++++++++++++++++++++++
|
|
|
0a122b |
tests/qemu-iotests/070.out | 8 +++++
|
|
|
0a122b |
tests/qemu-iotests/group | 1 +
|
|
|
0a122b |
3 files changed, 76 insertions(+), 0 deletions(-)
|
|
|
0a122b |
create mode 100755 tests/qemu-iotests/070
|
|
|
0a122b |
create mode 100644 tests/qemu-iotests/070.out
|
|
|
0a122b |
|
|
|
0a122b |
diff --git a/tests/qemu-iotests/070 b/tests/qemu-iotests/070
|
|
|
0a122b |
new file mode 100755
|
|
|
0a122b |
index 0000000..41bf100
|
|
|
0a122b |
--- /dev/null
|
|
|
0a122b |
+++ b/tests/qemu-iotests/070
|
|
|
0a122b |
@@ -0,0 +1,67 @@
|
|
|
0a122b |
+#!/bin/bash
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# Test VHDX log replay from an image with a journal that needs to be
|
|
|
0a122b |
+# replayed
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# Copyright (C) 2013 Red Hat, Inc.
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# This program is free software; you can redistribute it and/or modify
|
|
|
0a122b |
+# it under the terms of the GNU General Public License as published by
|
|
|
0a122b |
+# the Free Software Foundation; either version 2 of the License, or
|
|
|
0a122b |
+# (at your option) any later version.
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# This program is distributed in the hope that it will be useful,
|
|
|
0a122b |
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
|
|
0a122b |
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
|
|
|
0a122b |
+# GNU General Public License for more details.
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# You should have received a copy of the GNU General Public License
|
|
|
0a122b |
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
|
|
|
0a122b |
+#
|
|
|
0a122b |
+
|
|
|
0a122b |
+# creator
|
|
|
0a122b |
+owner=jcody@redhat.com
|
|
|
0a122b |
+
|
|
|
0a122b |
+seq=`basename $0`
|
|
|
0a122b |
+echo "QA output created by $seq"
|
|
|
0a122b |
+
|
|
|
0a122b |
+here=`pwd`
|
|
|
0a122b |
+tmp=/tmp/$$
|
|
|
0a122b |
+status=1 # failure is the default!
|
|
|
0a122b |
+
|
|
|
0a122b |
+_cleanup()
|
|
|
0a122b |
+{
|
|
|
0a122b |
+ _cleanup_test_img
|
|
|
0a122b |
+}
|
|
|
0a122b |
+trap "_cleanup; exit \$status" 0 1 2 3 15
|
|
|
0a122b |
+
|
|
|
0a122b |
+# get standard environment, filters and checks
|
|
|
0a122b |
+. ./common.rc
|
|
|
0a122b |
+. ./common.filter
|
|
|
0a122b |
+
|
|
|
0a122b |
+_supported_fmt vhdx
|
|
|
0a122b |
+_supported_proto generic
|
|
|
0a122b |
+_supported_os Linux
|
|
|
0a122b |
+
|
|
|
0a122b |
+# With the log replayed, the pattern 0xa5 extends to 0xc025000
|
|
|
0a122b |
+# If the log was not replayed, it would only extend to 0xc000000
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# This image is a 10G dynamic image, with 4M block size, and 1 unplayed
|
|
|
0a122b |
+# data sector in the log
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# This image was created with qemu-img, however it was verified using
|
|
|
0a122b |
+# Hyper-V to properly replay the logs and give the same post-replay
|
|
|
0a122b |
+# image as qemu.
|
|
|
0a122b |
+_use_sample_img iotest-dirtylog-10G-4M.vhdx.bz2
|
|
|
0a122b |
+
|
|
|
0a122b |
+echo
|
|
|
0a122b |
+echo "=== Verify open image read-only fails, due to dirty log ==="
|
|
|
0a122b |
+$QEMU_IO -r -c "read -pP 0xa5 0 18M" "$TEST_IMG" 2>&1 | grep -o "Permission denied"
|
|
|
0a122b |
+
|
|
|
0a122b |
+echo "=== Verify open image replays log ==="
|
|
|
0a122b |
+$QEMU_IO -c "read -pP 0xa5 0 18M" "$TEST_IMG" | _filter_qemu_io
|
|
|
0a122b |
+
|
|
|
0a122b |
+# success, all done
|
|
|
0a122b |
+echo "*** done"
|
|
|
0a122b |
+rm -f $seq.full
|
|
|
0a122b |
+status=0
|
|
|
0a122b |
diff --git a/tests/qemu-iotests/070.out b/tests/qemu-iotests/070.out
|
|
|
0a122b |
new file mode 100644
|
|
|
0a122b |
index 0000000..9db8ff2
|
|
|
0a122b |
--- /dev/null
|
|
|
0a122b |
+++ b/tests/qemu-iotests/070.out
|
|
|
0a122b |
@@ -0,0 +1,8 @@
|
|
|
0a122b |
+QA output created by 070
|
|
|
0a122b |
+
|
|
|
0a122b |
+=== Verify open image read-only fails, due to dirty log ===
|
|
|
0a122b |
+Permission denied
|
|
|
0a122b |
+=== Verify open image replays log ===
|
|
|
0a122b |
+read 18874368/18874368 bytes at offset 0
|
|
|
0a122b |
+18 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+*** done
|
|
|
0a122b |
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
|
|
|
0a122b |
index 1a182ed..0867b0f 100644
|
|
|
0a122b |
--- a/tests/qemu-iotests/group
|
|
|
0a122b |
+++ b/tests/qemu-iotests/group
|
|
|
0a122b |
@@ -68,3 +68,4 @@
|
|
|
0a122b |
065 rw auto
|
|
|
0a122b |
067 rw auto
|
|
|
0a122b |
068 rw auto
|
|
|
0a122b |
+070 rw auto
|
|
|
0a122b |
--
|
|
|
0a122b |
1.7.1
|
|
|
0a122b |
|